import cg
import game
import time

data = cg.load()
try:
    g = game.UltimateTicTacToe.load(data)
    we_are = game.Y
except Exception:
    g = game.UltimateTicTacToe()
    we_are = game.X
    data = g.dump()
    cg.dump(data)

if not g.is_virgin():
    print("game ongoing: entering spectator mode")
    while True:
        time.sleep(3)
        new = cg.load()
        if new is None:
            print("game ended")
            break
        if new != data:
            data = new
            print("\033[2J", end="")
            try:
                print(game.UltimateTicTacToe.load(data).render(None))
            except Exception:
                pass

SPACES = [(0, 0), (1, 0), (2, 0), (0, 1), (1, 1), (2, 1), (0, 2), (1, 2), (2, 2)]

def draw_board(g, selected):
    print("\033[2J" + "\n"*1000, end="")
    print("you are", "XO"[we_are-1])
    print(g.render(selected))

while True:
    draw_board(g, None)
    if g.to_play != we_are:
        print("waiting for enemy move")
        time.sleep(3)
        d = cg.load()
        if d is None:
            print("you lost")
            break
        g = game.UltimateTicTacToe.load(d)
        continue
    selected_space = g.next_space
    draw_board(g, selected_space)
    while True:
        if selected_space:
            if not g.next_space:
                print("you may do j to pick a different subboard or 1-9 to draw in a cell")
            else:
                print(selected_space, g.next_space)
                print("do 1-9 to draw in a cell")
        else:
            print("do 1-9 to pick a subboard")
        inp = input("> ")
        if inp == "j" and not g.next_space and selected_space:
            selected_space = None
            draw_board(g, selected_space)
        elif inp.isdigit() and 1 <= int(inp) <= 9:
            space = SPACES[int(inp)-1]
            if not selected_space:
                selected_space = space
                draw_board(g, selected_space)
            else:
                if g.make_move(*selected_space, *space):
                    print("you won")
                    exit(0)
                cg.dump(g.dump())
                break
        else:
            print("you may not do that")
            continue
